diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 9ff87705c..2a9e7d557 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -3095,7 +3088,7 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean canMineBlock(Player entityplayer, int i, int j, int k)
+    public boolean canMineBlock(Player entityplayer, int x, int y, int z)
     {
         return true;
     }
@@ -3118,11 +3111,11 @@ public class World implements WorldSource {
         for(int i = 0; i < unloadedEntityList.size(); i++)
         {
             Entity entity = unloadedEntityList.get(i);
-            int l = entity.chunkCoordX;
-            int j1 = entity.chunkCoordZ;
-            if(entity.addedToChunk && isChunkLoaded(l, j1))
+            int cX = entity.chunkCoordX;
+            int cZ = entity.chunkCoordZ;
+            if(entity.addedToChunk && isChunkLoaded(cX, cZ))
             {
-                getChunkFromChunkCoords(l, j1).removeEntity(entity);
+                getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
         }
 
@@ -3132,30 +3125,30 @@ public class World implements WorldSource {
         }
 
         unloadedEntityList.clear();
-        for(int k = 0; k < loadedEntityList.size(); k++)
+        for(int i = 0; i < loadedEntityList.size(); i++)
         {
-            Entity entity1 = loadedEntityList.get(k);
-            if(entity1.vehicle != null)
+            Entity entity = loadedEntityList.get(i);
+            if(entity.vehicle != null)
             {
-                if(!entity1.vehicle.isRemoved() && entity1.vehicle.getPassenger() == entity1)
+                if(!entity.vehicle.isRemoved() && entity.vehicle.getPassenger() == entity)
                 {
                     continue;
                 }
-                entity1.vehicle.setPassenger(null);
-                entity1.vehicle = null;
+                entity.vehicle.setPassenger(null);
+                entity.vehicle = null;
             }
-            if(!entity1.removed)
+            if(!entity.removed)
             {
                 continue;
             }
-            int i1 = entity1.chunkCoordX;
-            int k1 = entity1.chunkCoordZ;
-            if(entity1.addedToChunk && isChunkLoaded(i1, k1))
+            int cX = entity.chunkCoordX;
+            int cZ = entity.chunkCoordZ;
+            if(entity.addedToChunk && isChunkLoaded(cX, cZ))
             {
-                getChunkFromChunkCoords(i1, k1).removeEntity(entity1);
+                getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
-            loadedEntityList.remove(k--);
-            releaseEntitySkin(entity1);
+            loadedEntityList.remove(i--);
+            releaseEntitySkin(entity);
         }
 
     }
@@ -3187,7 +3180,7 @@ public class World implements WorldSource {
     public void updateEnoughPlayersSleepingFlag(Player player)
     {
         enoughPlayersSleeping = false;
-        if(players.size() > 0) {
+        if(!players.isEmpty()) {
             int playersSleeping = 0;
             int req = getPlayersRequiredToSkipNight();
             for(Player p : players)
@@ -3206,19 +3199,11 @@ public class World implements WorldSource {
     protected void wakeUpAllPlayers()
     {
         enoughPlayersSleeping = false;
-        Iterator iterator = players.iterator();
-        do
-        {
-            if(!iterator.hasNext())
-            {
-                break;
-            }
-            Player entityplayer = (Player)iterator.next();
-            if(entityplayer.isPlayerSleeping())
-            {
+        for (Player entityplayer : players) {
+            if (entityplayer.isPlayerSleeping()) {
                 entityplayer.wakeUpPlayer(false, false);
             }
-        } while(true);
+        }
         if (getCurrentWeather() != null && getCurrentWeather().spawnRainParticles)
         {
             weatherManager.overrideWeather(worldType.getDefaultWeather());
@@ -3263,14 +3248,14 @@ public class World implements WorldSource {
         return true;
     }
 
-    public void setSavedData(String s, SavedData mapdatabase)
+    public void setSavedData(String id, SavedData savedData)
     {
-        savedDataStorage.set(s, mapdatabase);
+        savedDataStorage.set(id, savedData);
     }
 
-    public SavedData getSavedData(Class class1, String s)
+    public SavedData getSavedData(Class<? extends SavedData> saveDataClass, String id)
     {
-        return savedDataStorage.load(class1, s);
+        return savedDataStorage.load(saveDataClass, id);
     }
 
     public int getUniqueDataId(String s)
@@ -3301,10 +3286,10 @@ public class World implements WorldSource {
         double x1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
         double y1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
         double z1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-        ItemEntity entityitem = new ItemEntity(this, (double) x + x1, (double) y + y1, (double) z + z1, itemStack);
-        entityitem.pickupDelay = 10;
-        entityJoinedWorld(entityitem);
-        return entityitem;
+        ItemEntity item = new ItemEntity(this, (double) x + x1, (double) y + y1, (double) z + z1, itemStack);
+        item.pickupDelay = 10;
+        entityJoinedWorld(item);
+        return item;
     }
     public void sendGlobalMessage(String message){
         for (Player player: players){
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 3d86cbb7f..c3d5908f1 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -260,7 +260,8 @@ public class Chunk
         return getSection(y / ChunkSection.SECTION_SIZE_Y).getBlock(x, y % ChunkSection.SECTION_SIZE_Y, z);
     }
 
-    public boolean setBlockIDWithMetadata(int x, int y, int z, int id, int data)
+    // will not trigger onBlockRemoved or onBlockPlacedByWorld
+    public boolean setBlockIDWithMetadataRaw(int x, int y, int z, int id, int data)
     {
         if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return false;
 
@@ -279,10 +280,6 @@ public class Chunk
 
         int worldX = xPosition * CHUNK_SIZE_X + x;
         int worldZ = zPosition * CHUNK_SIZE_Z + z;
-        if(currentId != 0 && !world.isClientSide)
-        {
-            Block.blocksList[currentId].onBlockRemoved(world, worldX, y, worldZ, currentData);
-        }
 
         if(!world.worldType.hasCeiling())
         {
@@ -300,45 +297,63 @@ public class Chunk
         world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
         lightGaps(x, z);
 
-        if(Block.getBlock(id) != null) {
-            Block.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
-        }
-
         isModified = true;
         return true;
     }
 
-    public boolean setBlockID(int x, int y, int z, int id)
-    {
-        return setBlockIDWithMetadata(x, y, z, id, 0);
-    }
-
-    // will not trigger onBlockRemoved or onBlockAdded
-    public boolean setBlockIDRaw(int x, int y, int z, int id)
+    public boolean setBlockIDWithMetadata(int x, int y, int z, int id, int data)
     {
         if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return false;
 
         ChunkSection section = getSection(y / ChunkSection.SECTION_SIZE_Y);
+        int heightValue = getHeightValue(x, z);
 
         int currentId = section.getBlock(x, y % ChunkSection.SECTION_SIZE_Y, z);
-        if(currentId == id) {
+        int currentData = section.getData(x, y % ChunkSection.SECTION_SIZE_Y, z);
+
+        if(currentId == id && currentData == data) {
             return false;
         }
 
         section.setBlock(x, y % ChunkSection.SECTION_SIZE_Y, z, id);
-        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, 0);
+        section.setData(x, y % ChunkSection.SECTION_SIZE_Y, z, data);
 
         int worldX = xPosition * CHUNK_SIZE_X + x;
         int worldZ = zPosition * CHUNK_SIZE_Z + z;
+        if(currentId != 0 && !world.isClientSide)
+        {
+            Block.blocksList[currentId].onBlockRemoved(world, worldX, y, worldZ, currentData);
+        }
+
+        if(!world.worldType.hasCeiling())
+        {
+            if(Block.lightBlock[id & 0x3fff] != 0) {
+                if(y >= heightValue) {
+                    recalcHeight(x, y + 1, z);
+                }
+            }
+            else if(y == heightValue - 1) {
+                recalcHeight(x, y, z);
+            }
+            world.scheduleLightingUpdate(LightLayer.Sky, worldX, y, worldZ, worldX, y, worldZ);
+        }
 
         world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
-        world.scheduleLightingUpdate(LightLayer.Sky, worldX, y, worldZ, worldX, y, worldZ);
         lightGaps(x, z);
 
+        if(Block.getBlock(id) != null) {
+            Block.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
+        }
+
         isModified = true;
         return true;
     }
 
+    public boolean setBlockID(int x, int y, int z, int id)
+    {
+        return setBlockIDWithMetadata(x, y, z, id, 0);
+    }
+
     public int getBlockMetadata(int x, int y, int z)
     {
         if (x < 0 || x >= CHUNK_SIZE_X || y < 0 || y >= CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y || z < 0 || z >= CHUNK_SIZE_Z) return 0;
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index a291db9a6..a0b76faa2 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -82,22 +82,22 @@ public class ChunkCache
         return chunkArray[l][i1].getBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
-    public boolean getBlockLitInteriorSurface(int i, int j, int k)
+    public boolean getBlockLitInteriorSurface(int x, int y, int z)
     {
-        if(i < 0xfe17b800 || k < 0xfe17b800 || i >= 0x1e84800 || k > 0x1e84800)
+        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
         {
             return true;
         }
-        if(j < 0)
+        if(y < 0)
         {
             return true;
         }
-        if(j >= worldObj.getHeightBlocks())
+        if(y >= worldObj.getHeightBlocks())
         {
             return true;
         } else
         {
-            return Block.getIsLitInteriorSurface(worldObj, i, j, k);
+            return Block.getIsLitInteriorSurface(worldObj, x, y, z);
         }
     }
 
@@ -140,26 +140,26 @@ public class ChunkCache
         return worldObj.worldType.getBrightnessRamp()[getLightValue(x, y, z)];
     }
 
-    public int getLightValue(int i, int j, int k)
+    public int getLightValue(int x, int y, int z)
     {
-        return getLightValueExt(i, j, k, true);
+        return getLightValueExt(x, y, z, true);
     }
 
-    public int getLightValueExt(int i, int j, int k, boolean flag)
+    public int getLightValueExt(int x, int y, int z, boolean first)
     {
-        if(i < 0xfe17b800 || k < 0xfe17b800 || i >= 0x1e84800 || k > 0x1e84800)
+        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
         {
             return 15;
         }
-        if(flag)
+        if(first)
         {
-            if(getBlockLitInteriorSurface(i, j, k))
+            if(getBlockLitInteriorSurface(x, y, z))
             {
-                int k1 = getLightValueExt(i, j + 1, k, false);
-                int i2 = getLightValueExt(i + 1, j, k, false);
-                int j2 = getLightValueExt(i - 1, j, k, false);
-                int k2 = getLightValueExt(i, j, k + 1, false);
-                int l2 = getLightValueExt(i, j, k - 1, false);
+                int k1 = getLightValueExt(x, y + 1, z, false);
+                int i2 = getLightValueExt(x + 1, y, z, false);
+                int j2 = getLightValueExt(x - 1, y, z, false);
+                int k2 = getLightValueExt(x, y, z + 1, false);
+                int l2 = getLightValueExt(x, y, z - 1, false);
                 if(i2 > k1)
                 {
                     k1 = i2;
@@ -179,11 +179,11 @@ public class ChunkCache
                 return k1;
             }
         }
-        if(j < 0)
+        if(y < 0)
         {
             return 0;
         }
-        if(j >= worldObj.getHeightBlocks())
+        if(y >= worldObj.getHeightBlocks())
         {
             int i1 = 15 - worldObj.skyDarken;
             if(i1 < 0)
@@ -193,9 +193,9 @@ public class ChunkCache
             return i1;
         } else
         {
-            int j1 = Math.floorDiv(i, Chunk.CHUNK_SIZE_X) - chunkX;
-            int l1 = Math.floorDiv(k, Chunk.CHUNK_SIZE_Z) - chunkZ;
-            return chunkArray[j1][l1].getRawBrightness(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), worldObj.skyDarken);
+            int j1 = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
+            int l1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
+            return chunkArray[j1][l1].getRawBrightness(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), worldObj.skyDarken);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCoordinates.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCoordinates.java
index 40df26fb3..5677ee88a 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCoordinates.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCoordinates.java
@@ -47,11 +47,11 @@ public class ChunkCoordinates implements Comparable<ChunkCoordinates> {
 		}
 	}
 
-	public double getSqDistanceTo(int i, int j, int k) {
-		int l = x - i;
-		int i1 = y - j;
-		int j1 = z - k;
-		return Math.sqrt(l * l + i1 * i1 + j1 * j1);
+	public double getSqDistanceTo(int x, int y, int z) {
+		int dx = this.x - x;
+		int dy = this.y - y;
+		int dz = this.z - z;
+		return Math.sqrt(dx * dx + dy * dy + dz * dz);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
new file mode 100644
index 000000000..3f8e56fb6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -0,0 +1,72 @@
+package net.minecraft.core.world.config.spawning;
+
+import com.mojang.nbt.ByteTag;
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.Tag;
+import net.minecraft.core.world.World;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Locale;
+import java.util.Map;
+
+public class SpawnerConfig {
+    private boolean allowPassive = true;
+    private boolean allowHostile = true;
+    private final Map<String, Boolean> mobSpawnOverrides = new HashMap<>();
+
+    public boolean canPassiveSpawn(World world) {
+        return allowPassive;
+    }
+
+    public void setPassiveSpawning(boolean flag) {
+        allowPassive = flag;
+    }
+
+    public boolean canHostileSpawn(World world) {
+        return allowHostile && world.getDifficulty().canHostileMobsSpawn();
+    }
+
+    public void setHostileSpawning(boolean flag) {
+        allowHostile = flag;
+    }
+
+    public boolean canMobSpawn(String mobID) {
+        return mobSpawnOverrides.getOrDefault(mobID.toLowerCase(Locale.ROOT), true);
+    }
+
+    public void setMobSpawn(String mobID, boolean flag) {
+        mobSpawnOverrides.put(mobID.toLowerCase(Locale.ROOT), flag);
+    }
+
+    public Collection<Map.Entry<String, Boolean>> getSpawnEntries() {
+        return mobSpawnOverrides.entrySet();
+    }
+
+    public void writeToTag(CompoundTag tag) {
+        tag.putBoolean("passive", allowPassive);
+        tag.putBoolean("hostile", allowHostile);
+        CompoundTag overridesTag = new CompoundTag();
+        for (Map.Entry<String, Boolean> e : mobSpawnOverrides.entrySet()) {
+            overridesTag.putBoolean(e.getKey(), e.getValue());
+        }
+        tag.putCompound("overrides", overridesTag);
+    }
+
+    public void readFromTag(CompoundTag tag) {
+        allowPassive = tag.getBoolean("passive");
+        allowHostile = tag.getBoolean("hostile");
+        CompoundTag overrides = tag.getCompound("overrides");
+        for (Map.Entry<String, Tag<?>> tagEntry : overrides.getValue().entrySet()) {
+            mobSpawnOverrides.put(tagEntry.getKey(), ((ByteTag)tagEntry.getValue()).getValue() != 0);
+        }
+    }
+
+    public static SpawnerConfig createFromTag(CompoundTag tag) {
+        SpawnerConfig config = new SpawnerConfig();
+        if (tag != null) {
+            config.readFromTag(tag);
+        }
+        return config;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
index cb42e364f..2a3ed91ff 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
@@ -125,13 +125,13 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         System.arraycopy(ai, 0, foliageCoords, 0, k);
     }
 
-    void crossSection(int i, int j, int k, float f, byte byte0, int l)
+    void crossSection(int x, int y, int z, float f, byte byte0, int l)
     {
         int i1 = (int)((double)f + 0.61799999999999999D);
         byte byte1 = axisConversionArray[byte0];
         byte byte2 = axisConversionArray[byte0 + 3];
         int[] ai = {
-                i, j, k
+                x, y, z
         };
         int ai1[] = {
                 0, 0, 0
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
index e5c5d7cb6..0eb9c3b0f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
@@ -14,6 +14,7 @@ import java.util.Random;
 
 public class WorldFeatureTreeFancyRainforest extends WorldFeature
 {
+    // TODO these fucking hellish copy pasted fancy tree code classes are the most miserable things to parse
 	protected int leavesID;
 	protected int logID;
     @MethodParametersAnnotation(names = {"leavesID", "logID"})
@@ -290,7 +291,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
 
     boolean func_527_c(int i)
     {
-        return (double)i >= (double)field_878_e * 0.20000000000000001D;
+        return (double)i >= (double)field_878_e * 0.2D;
     }
 
     void func_529_c()
diff --git a/src/main/java/net/minecraft/core/world/pathfinder/Node.java b/src/main/java/net/minecraft/core/world/pathfinder/Node.java
index 31fc6d1e7..c6861796d 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/Node.java
+++ b/src/main/java/net/minecraft/core/world/pathfinder/Node.java
@@ -25,9 +25,9 @@ public class Node
         hash = createHash(x, y, z);
     }
 
-    public static int createHash(int i, int j, int k)
+    public static int createHash(int x, int y, int z)
     {
-        return j & 0xff | (i & 0x7fff) << 8 | (k & 0x7fff) << 24 | (i >= 0 ? 0 : 0x80000000) | (k >= 0 ? 0 : 0x8000);
+        return y & 0xff | (x & 0x7fff) << 8 | (z & 0x7fff) << 24 | (x >= 0 ? 0 : 0x80000000) | (z >= 0 ? 0 : 0x8000);
     }
 
     public float distanceTo(Node other)
diff --git a/src/main/java/net/minecraft/core/world/save/LevelData.java b/src/main/java/net/minecraft/core/world/save/LevelData.java
index 14e4a405f..9277ba43b 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -6,6 +6,7 @@ import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
@@ -33,6 +34,7 @@ public class LevelData
     private @NotNull Difficulty difficulty = Difficulty.NORMAL;
     private boolean difficultyLocked;
     private GameRuleCollection gameRules;
+    private SpawnerConfig spawnerConfig;
 
 
     public LevelData(CompoundTag tag)
@@ -41,17 +43,19 @@ public class LevelData
     }
 
     //do *not* add @NotNull to name here, breaks modding for some abstract reason
-    public LevelData(long seed, String name)
+    public LevelData(long seed, @NotNull String name)
     {
         randomSeed = seed;
         levelName = name;
+        spawnerConfig = new SpawnerConfig();
         gameRules = new GameRuleCollection();
     }
 
-    public LevelData(long seed, String name, GameRuleCollection gameRules)
+    public LevelData(long seed, @NotNull String name, GameRuleCollection gameRules)
     {
         randomSeed = seed;
         levelName = name;
+        spawnerConfig = new SpawnerConfig();
         this.gameRules = gameRules;
     }
 
@@ -70,7 +74,8 @@ public class LevelData
         saveVersion = levelData.saveVersion;
         cheatsEnabled = levelData.cheatsEnabled;
         gamemode = levelData.gamemode;
-        gameRules = levelData.gameRules.copy();
+        gameRules = levelData.gameRules;
+        spawnerConfig = levelData.getSpawnerConfig();
         difficulty = levelData.difficulty;
         difficultyLocked = levelData.difficultyLocked;
     }
@@ -113,6 +118,10 @@ public class LevelData
         {
             gameRules = new GameRuleCollection();
         }
+
+        if (spawnerConfig == null) {
+            spawnerConfig = new SpawnerConfig();
+        }
     }
 
     public CompoundTag getNBTTagCompound()
@@ -162,6 +171,12 @@ public class LevelData
         CompoundTag gameRulesTag = new CompoundTag();
         GameRuleCollection.writeToNBT(gameRulesTag, gameRules);
         levelTag.put("GameRules", gameRulesTag);
+
+        if (spawnerConfig != null) {
+            CompoundTag spawnerConfigTag = new CompoundTag();
+            spawnerConfig.writeToTag(spawnerConfigTag);
+            levelTag.put("SpawnConfig", spawnerConfigTag);
+        }
     }
 
     private void readFromCompoundTag(CompoundTag tag)
@@ -193,6 +208,13 @@ public class LevelData
         {
             gameRules = new GameRuleCollection();
         }
+
+        if (tag.containsKey("SpawnConfig")) {
+            CompoundTag spawnConfigTag = tag.getCompound("SpawnConfig");
+            spawnerConfig = SpawnerConfig.createFromTag(spawnConfigTag);
+        } else {
+            spawnerConfig = new SpawnerConfig();
+        }
     }
 
     public long getRandomSeed()
@@ -312,6 +334,10 @@ public class LevelData
         return gameRules;
     }
 
+    public SpawnerConfig getSpawnerConfig() {
+        return spawnerConfig;
+    }
+
     public boolean getCheatsEnabled()
     {
     	return cheatsEnabled;
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java b/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
index a4380a8b1..c2d068a1d 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
@@ -137,4 +137,8 @@ public final class SeasonManagerCycle
         int seasonTime = (int)(getSeasonLengthTicks(season) * progress);
         return seasonTime / Global.DAY_LENGTH_TICKS;
     }
+
+    public int getYearLengthTicks() {
+        return yearLengthTicks;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index 417b846d5..819bf4333 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.weather;
 
 import net.minecraft.core.Global;
+import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Season;
@@ -124,7 +125,9 @@ public class WeatherManager {
             }
         }
 
-        weatherDuration--;
+        if (world.getGameRuleValue(GameRules.DO_WEATHER_CYCLE)) {
+            weatherDuration--;
+        }
         if (weatherDuration <= 0)
         {
             if (currentWeather != world.worldType.getDefaultWeather()) {
@@ -151,14 +154,8 @@ public class WeatherManager {
         }
 
         world.dimensionData.setCurrentWeather(currentWeather);
-        if (nextWeather != null)
-        {
-            world.dimensionData.setNextWeather(nextWeather);
-        }
-        else
-        {
-            world.dimensionData.setNextWeather(null);
-        }
+        world.dimensionData.setNextWeather(nextWeather);
+
         world.dimensionData.setWeatherDuration(weatherDuration);
         world.dimensionData.setWeatherIntensity(weatherIntensity);
         world.dimensionData.setWeatherPower(weatherPower);
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index 4a82a9c4b..274711ec0 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -58,12 +58,12 @@ zLoop:		for (int z = 0; z < 16; z++)
 				{
 					if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id)
 					{
-						chunk.setBlockIDRaw(x, y, z, Blocks.LAYER_SNOW.id);
+						chunk.setBlockIDWithMetadataRaw(x, y, z, Blocks.LAYER_SNOW.id, chunk.getBlockMetadata(x, y, z));
 					}
 					else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id && chunk.getBlockMetadata(x, y - 1, z) == 0) {
-						chunk.setBlockIDRaw(x, y - 1, z, Blocks.ICE.id);
+						chunk.setBlockIDWithMetadataRaw(x, y - 1, z, Blocks.ICE.id, chunk.getBlockMetadata(x, y - 1, z));
 						if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id){
-							chunk.setBlockIDRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id);
+							chunk.setBlockIDWithMetadataRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id, chunk.getBlockMetadata(x, y - 2, z));
 						}
 					}
 				}
diff --git a/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index e3c361dfd..963195b02 100644
--- a/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -45,6 +45,7 @@ public class SmeltingGenerator {
         blastRecipe("cobble_permafrost_to_permafrost", Blocks.COBBLE_PERMAFROST.getDefaultStack(), Blocks.PERMAFROST.getDefaultStack());
         blastRecipe("cobble_stone_to_slate", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.SLATE.getDefaultStack());
         blastRecipe("iron_ingot_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), Items.INGOT_STEEL_CRUDE.getDefaultStack());
+        blastRecipe("cobble_netherrack_to_igneous_netherrack", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.COBBLE_NETHERRACK_IGNEOUS.getDefaultStack());
     }
 
     private static void furnaceRecipe(String id, ItemStack input, ItemStack output) {
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 7ad832bdf..e21991249 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -28,7 +28,6 @@ import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -112,7 +111,9 @@ public class MinecraftServer
     public int autoSaveInterval = 5;
     public int chunksSavedPerAutosave = 24;
     public boolean forceSaveAllChunksOnAutosave = false;
-    public SpawnerMobs.SpawnerConfig spawnerConfig = new SpawnerMobs.SpawnerConfig();
+
+    private boolean spawnAnimals;
+    private boolean spawnHostiles;
 
     public MinecraftServer()
     {
@@ -174,8 +175,8 @@ public class MinecraftServer
         propertyManager = new PropertyManager(new File("server.properties"));
         String s = propertyManager.getStringProperty("server-ip", "");
         onlineMode = propertyManager.getBooleanProperty("online-mode", true);
-        spawnerConfig.setPassiveSpawning(propertyManager.getBooleanProperty("spawn-animals", true));
-        spawnerConfig.setHostileSpawning(propertyManager.getBooleanProperty("spawn-monsters", true));
+        spawnAnimals = propertyManager.getBooleanProperty("spawn-animals", true);
+        spawnHostiles = propertyManager.getBooleanProperty("spawn-monsters", true);
         pvpOn = propertyManager.getBooleanProperty("pvp", true);
         allowFlight = propertyManager.getBooleanProperty("allow-flight", false);
         statsToken = propertyManager.getStringProperty("stats-token", "only-enter-a-value-if-you-are-a-registered-server");
@@ -409,16 +410,18 @@ public class MinecraftServer
             WorldServer worldServer;
             if (dimId == 0)
             {
-                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, defaultWorldType, l, spawnerConfig);
+                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, defaultWorldType, l);
             }
             else
             {
-                worldServer = new WorldServerMulti(this, saveHandler, worldDirName, dimId, dimension.defaultWorldType, l, dimensionWorlds.get(0), spawnerConfig);
+                worldServer = new WorldServerMulti(this, saveHandler, worldDirName, dimId, dimension.defaultWorldType, l, dimensionWorlds.get(0));
             }
             dimensionWorlds.put(dimId, worldServer);
             worldServer.addListener(new WorldManager(this, dimensionWorlds.get(dimId)));
             worldServer.setDifficulty(difficulty, true);
             worldServer.sleepPercent = sleepPercentage;
+            worldServer.getSpawnerConfig().setHostileSpawning(spawnHostiles);
+            worldServer.getSpawnerConfig().setPassiveSpawning(spawnAnimals);
             playerList.setPlayerManager(dimensionWorlds);
         }
 
@@ -697,9 +700,9 @@ public class MinecraftServer
 
     }
 
-    public void func_6022_a(IUpdatePlayerListBox iupdateplayerlistbox)
+    public void addPlayerListBox(IUpdatePlayerListBox listBox)
     {
-        playerListBoxes.add(iupdateplayerlistbox);
+        playerListBoxes.add(listBox);
     }
 
     public static void main(String[] args)
